/****************************************************************************************/
/***DEEP FIRST SEARCH basado en pseudocodigo de introduction to algorithms deT.CORMEN****/
/****************************************************************************************/
//LIBRERIAS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//CONSTANTES
#define WHITE 0 // NODO NO VISITADO
#define GREY 1	// NODO EN VISITA
#define BLACK 2	// NODO VISITADO

// VARIABLES
int *d, *f, *p, *color, time;
int i,j, nciclos=0, **A;

/****************************************************************************************/
/****************************************************************************************/
//FUNCION DFSvisit recursiva

void DFSvisit(int i,int n){
	
	int j,k,l, cycle;
	color[i]=1;
	time++;
	d[i]=time; // forma arreglo de tiempos de entrada


	
	for(j=0;j<n;j++)
	{

		if(A[i][j]==1)
		{	
			//LINEA OPTATIVA QUE IMPRIME INFORMACION SOBRE LOS NODOS QUE SE VISITAN
			//printf("node %2i color=%2d father=%2d ti=%2d\n",i,color[j],p[i],d[i]);
			
		if(color[j]==GREY){
				nciclos++; // contador de ciclos
        printf("ciclo %2i: %i<",nciclos, j); // imprime el numero de ciclo y el nuemero de
											 // nodo donde termina un ciclo (se encontro un GREY)
        
        for( cycle=i; cycle!=j; cycle=p[cycle]) // iteracion que imprime los padres mientras no se
										// descubra que un padre es el nodo desde termino el ciclo
			printf("%i<", cycle);
		printf("%i\n",j);	// finalmente imprime el nodo desde el que se termino el ciclo para indicar
							// que el padre del padre del padre... era el mismo y se cumplio un ciclo.
		
				}
			if(color[j]==WHITE)
			{
				p[j]=i;
				DFSvisit(j,n);
			}
		
		}
		
	}
	
	color[i]=2;
	f[i]=time++; //forma el arreglo de tiempos de salida (no usados en este programa)
	

}

/****************************************************************************************/
/****************************************************************************************/
//FUNCION DFS QUE LLAMA A DFSvisit
void DFS(int **A,int n) {



	d=(int *)malloc(n*sizeof(int)); /*creamos matriz tiempo de entrada de tama� n*/
	for(i=0;i<n;i++){ // la llenamos de ceros
		d[i]=0;}
	p=(int *)malloc(n*sizeof(int)); /*creamos matriz de padres de tama� n*/
	for(i=0;i<n;i++){ // la llenamos de -1, indicando infinito
		p[i]=-1;}
	f=(int *)malloc(n*sizeof(int)); /*creamos matriz tiempo de salida de tama� n*/
	for(i=0;i<n;i++){ // la llenamos de ceros
		f[i]=0;}
	color=(int *)malloc(n*sizeof(int)); /*creamos matriz de visitas(colores) de tama� n*/
	for(i=0;i<n;i++){ // la llenamos de ceros
		color[i]=0;}

	
	time=0;
	for(i=0;i<n;i++){
	if(color[i]==0){
		DFSvisit(i,n);
		}	
	}

}
/****************************************************************************************/
/****************************************************************************************/
